#define _GLIBCXX_USE_NANOSLEEP
#define _GLIBCXX_USE_SCHED_YIELD
#include <thread>
#include <iostream>
#include <cstdlib>
#include <mutex>
int sum = 0;
int tmp = 0;
std::mutex m;

void add(int n) { 
  //m.lock(); // A decommenter
  tmp = n;
  std::this_thread::sleep_for(
    std::chrono::milliseconds(std::rand()%30));
  sum+=tmp;
  //m.unlock(); // A decommenter
}


void loop(std::string p) {
  for(int i=0; i<10; i++) {
    std::this_thread::sleep_for(
      std::chrono::milliseconds(std::rand()%30));
    add(i);
    std::cout << p << "(" << i << ")" << std::endl;
  }
}

int main() {
  std::srand(std::time(0));
  std::thread t1(loop,"t1");
  std::thread t2(loop,"t2");
  t1.join();
  t2.join();
  std::cout << "total " << sum << std::endl;
  return 0;
}