#include <iostream>

void f(int& n)  { std::cout << "lvalue: " << n << std::endl; }
void f(int&& n) { std::cout << "rvalue: " << n << std::endl; }

template<class T> 
void test_forward(T&& t) {
	f(t);
	f(std::forward<T>(t));
}	

int main() {
	int i = 1;
	test_forward(i);
	test_forward(2);
	return 0;
}
